> For the complete documentation index, see [llms.txt](https://api-docs.nf.domains/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://api-docs.nf.domains/reference/integrators-guide/interactive-nfd-lookup.md).

# Interactive NFD lookup

## 'Looking up' an NFD interactively (debounce)

If you want to provide interactive search features for an NFD.  You can use the NFD 'search' endpoint using the prefix query parameter.

The endpoint is the /nfd/v2/search endpoint.  It takes many query parameters but only certain types should be specified at one time.

ie: prefix, but not owner or reservedFor. &#x20;

{% openapi src="/files/LUX7Ji30E1eiEMcVZkUr" path="/nfd/v2/search" method="get" %}
[openapi3.yaml](https://248579615-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FMrFth5XKC1eo3nu9xVre%2Fuploads%2FW7CFlA4K7snWCT3liMou%2Fopenapi3.yaml?alt=media\&token=0490decf-f3b6-4911-88c6-ed5a87e7872d)
{% endopenapi %}

### Example

<details>

<summary>Get first 4 matching names by prefix (forced 'thumbnail' view)</summary>

```json
http https://api.nf.domains/nfd/v2/search?prefix=patric&view=thumbnail&limit=4

{
    "nfds": [
        {
            "appID": 1184583458,
            "depositAccount": "MQ2QJHZSZ6A7ZXPFE2EPIWLYUMRRDO3DQBEO6NIQ2B5A5OJ4VMWOOI2AX4",
            "name": "patrick.voi.algo",
            "owner": "MQ2QJHZSZ6A7ZXPFE2EPIWLYUMRRDO3DQBEO6NIQ2B5A5OJ4VMWOOI2AX4",
            "parentAppID": 984682143,
            "properties": {},
            "state": "owned"
        },
        {
            "appID": 1016975892,
            "depositAccount": "SAC732VSDG3J7ZVDOIV7I5Y3REVCYB2EPMNU6PRLJY67L37YOARYSD2PDM",
            "name": "patricia.eth.algo",
            "owner": "SAC732VSDG3J7ZVDOIV7I5Y3REVCYB2EPMNU6PRLJY67L37YOARYSD2PDM",
            "parentAppID": 1016578024,
            "properties": {},
            "state": "owned"
        },
        {
            "appID": 1016975648,
            "depositAccount": "SAC732VSDG3J7ZVDOIV7I5Y3REVCYB2EPMNU6PRLJY67L37YOARYSD2PDM",
            "name": "patricia.btc.algo",
            "owner": "SAC732VSDG3J7ZVDOIV7I5Y3REVCYB2EPMNU6PRLJY67L37YOARYSD2PDM",
            "parentAppID": 1016575127,
            "properties": {},
            "state": "owned"
        },
        {
            "appID": 1016602998,
            "depositAccount": "MQ2QJHZSZ6A7ZXPFE2EPIWLYUMRRDO3DQBEO6NIQ2B5A5OJ4VMWOOI2AX4",
            "name": "patrick.btc.algo",
            "owner": "MQ2QJHZSZ6A7ZXPFE2EPIWLYUMRRDO3DQBEO6NIQ2B5A5OJ4VMWOOI2AX4",
            "parentAppID": 1016575127,
            "properties": {},
            "state": "owned"
        }
    ],
    "total": 10
}
```

</details>

The thumbnail view will return verified and userDefined avatars for names.  This way, the UI can show avatars with choices as well, as seen here in this NFDomains search UI example:

![](/files/TNPqGsSSALzQWpuAxfvd)

Note the verified.**avatarasaid** property in this example (same exists for banner, **bannerasaid** when fetching with other views).  For integrations that manage their own ASA caching, this may make it easier to reference already cached versions of the NFT image if the ASA id is used instead of IPFS CID references.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://api-docs.nf.domains/reference/integrators-guide/interactive-nfd-lookup.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
